Subject: Re: RE : Taxonomy draft - web replication problems

From: michael rabinovich <[email-masked]>
Date: Thu, 26 Aug 1999 11:41:17 -0400 (EDT)

> From [email-masked] Wed Aug 25 19:29 EDT 1999
> 
> 
> Other point: mirrors usually have a legal and published URL in their own
> right, irrespective of any synthesized mapping from URI-space to their
> instance of the cloned data. 
> 
> 	http://mirror.aarnet.edu.au/FreeBSD is a documented published
> 	URL to reach the same resources as http://www.freebsd.org/
> 
> Caches do not exist as terminal objects in themselves (for their content
> that is) in the same way.
> 
> I think this distinction matters because in compiling the set of rewrite
> rules for redirection in caches, to supplement any inter-cache ICPlike
> behaviour, you need a complete set of the known URL of the mirrors to
> make a complete set of the possible (and hence derive the preferential)
> rewrite rule to effect.
> 
> cheers
> 	-George
> --
> George Michaelson         |  DSTC Pty Ltd
> Email: [email-masked]    |  University of Qld 4072
> Phone: +61 7 3365 4310    |  Australia
>   Fax: +61 7 3365 4311    |  http://www.dstc.edu.au
> 
> 
> 

No-no-no!!  You are right that often times mirror do have distinct
URLs.  But this is a serious deficiency, and the one that is
disapearing as we speak.  among the problems:  

* It's not transparent to users; you rely on their good behaviour to 
  achieve geographical distribution or load balancing.

* If you set up a new mirror to releave the load on the existing site,
  at best you can count on NEW users to be load-balanced.  
  The old URL has been embedded by an unknown number of
  documents and bookmark files, and those will not change.  They will 
  continue generating   refs to the original site.  

* Setting up a mirror is an irrevocable decision.  Once you publicize
  the mirror URL, you cannot tear it down - people will embed it into
  their bookmarks and documents.  Yes, you can replace the content on
  the mirror with a stub that redirects requests, but fundamentally
  you cannot eliminate that mirror URL.

* Most sites prefer to have a single identity, which is undermined by
  multiple mirror URLs.
 
Different products take different approaches to avoiding this
deficiency.  But I should get off the soap box; if interested in my
opinions on this issue I discuss this stuff in more details in a paper
"Issues in Web Content Replication", see 
http://www.research.att.com/~misha/pubs.html#web.

Regards,
Misha

---

From: George Michaelson <[email-masked]>
Date: Fri, 27 Aug 1999 08:08:28 +1000

Misha, you speak of things "as they should be" which is good. I support this.

But Taxonomy also speaks of things "AS THEY ARE" and this is also good.

If we do not construct an ontology which can disambiguate between behaviours
in the real world now, how can we hope to understand the implementation of
our goals?

cheers
	-George

PS sometimes, knowing you use a mirror is a good thing. since there is no
   delayless propagation, mirrors and caches are almost by definition "stale"
   and so a user is entitled to know if they are subject to redirection, or
   choose to look at alternates. Again, we do not have this: but from an
   end-user perspective, isn't it a sort-of right? (right now, redirection
   like transparent proxy is rarely "concious" but perhaps in an AUP or
   contractual sense, it should be somehow?)